#!/bin/sh

# This test validates generating shell output suitable for use with eval.

set -e
set -u
set -x

VARS="$(printf '{"VAR1": 7, "VAR2": "abc"}' | "$RQ" -o sh)"

eval "$VARS"

if [ "$VAR1" != "7" ] ; then
	printf "VAR1 was '%s', but should have been '7'\n", "$VAR1"
	exit 1
fi

if [ "$VAR2" != "abc" ] ; then
	printf "VAR2 was '%s', but should have been 'abc'\n", "$VAR2"
	exit 1
fi
